;The end part
;### "Credits" scroller, upwards

                 processor 6502

;Memory map:
;$80-$ff Zero page

;$7000-$7fff Code+tmp_sprites

;$8000-$83ff Screen
screen_sprite_pointers = $83f8
;$8400-$87ff Text Charset

;$a000-$bfff Drawn sprites
;$c000-      Sprite Charset
;$e000-      Text


  include globals.s

  seg.u zp
  org $0080
zp_start:

savea: dc.b 0
savex: dc.b 0
savey: dc.b 0
nmi_savea: dc.b 0
nmi_savex: dc.b 0
nmi_savey: dc.b 0

part_finished: dc.b 0
IRQ_finished: dc.b 0
countdown_to_finished: dc.b 0

up_toggle:             dc.b 0  ;Sr en variabel som fsr scrollen at gs varannat svep.
up_current_row:        dc.b 0  ;verkar vara radnummer som vi skriver in ny text ps. 7158 Sndrar $03 (kar den med 1), wrap and $0f
up_current_rowpixel:   dc.b 0  ;verkar vara pixelnummer i en rad. 714d minskar den med 1, laddar om med #$14
up_irq_counter:        dc.b 0
up_sprites_ypos:       dc.b 0  ;har med sprite y-position att gra
up_current_displayrow: dc.b 0  ;har med sprite data att gra. ldx $07. lda $72a0,x. 712a kar $07 wrap and #$0f
up_textpoi:            dc.b 0,0 ;Pointer till text i upscreen
up_thisrow_sprx:       dc.b 0   ;SStts till #$40, x-pos fr en rad vi ritar i
up_current_xdraw:      dc.b 0   ;pixelpekare ps var vi Sr i raden nSr vi ritar
up_underline:          dc.b 0   ;#$80 = understrykning on
up_drawpoi:            dc.b 0,0 ;SStts till #0,($f * 2) + #$40 = Pekare ps de sprites vi ska rita i
up_draw_sprline:       dc.b 0   ;sStts till ($03 + #$e) and #$f. Troligtvis rad vi ritar ut ny text ps.
up_tmp:                dc.b 0   ;tempvariabel
up_thischar_width:     dc.b 0   ;bredd ps detta tecken vi ritar
up_charpoi:            dc.b 0,0 ;pointer till den sprite som tecknet finns i

up_sincou:             dc.b 0
up_cou:                dc.b 0
up_cou2:                dc.b 0

up_20:
 ds.b $10,0 ;Byte  0-15 frsn tecken
up_30:
 dc.b 0     ;#0
up_31:
 ds.b $10,0 ;Byte 16-31 frsn tecken
up_41:
 dc.b 0     ;#0
up_42:
 ds.b $11,0 ;Byte 32-47 sStts till #0

up_pause: dc.b 0

  seg code
  org $7000

;###
;### up-scroller
;###

start_up:
  ldx #0
.looop:
  lda #$00
  sta up_sprites+$0000,x
  sta up_sprites+$0100,x
  sta up_sprites+$0200,x
  sta up_sprites+$0300,x
  sta up_sprites+$0400,x
  sta up_sprites+$0500,x
  sta up_sprites+$0600,x
  sta up_sprites+$0700,x
  sta up_sprites+$0800,x
  sta up_sprites+$0900,x
  sta up_sprites+$0a00,x
  sta up_sprites+$0b00,x
  sta up_sprites+$0c00,x
  sta up_sprites+$0d00,x
  sta up_sprites+$0e00,x
  sta up_sprites+$0f00,x
  sta up_sprites+$1000,x
  sta up_sprites+$1100,x
  sta up_sprites+$1200,x
  sta up_sprites+$1300,x
  sta up_sprites+$1400,x
  sta up_sprites+$1500,x
  sta up_sprites+$1600,x
  sta up_sprites+$1700,x
  sta up_sprites+$1800,x
  sta up_sprites+$1900,x
  sta up_sprites+$1a00,x
  sta up_sprites+$1b00,x
  sta up_sprites+$1c00,x
  sta up_sprites+$1d00,x
  sta up_sprites+$1e00,x
  sta up_sprites+$1f00,x
  lda #$00
  sta $d800,x
  sta $d900,x
  sta $da00,x
  sta $daf7,x  
  inx
  bne .looop

  ldy #0
.nextro:
  tya
  asl
  tax  
.nextch:  
  txa
  ldx #0
  clc
  adc #$80
row:
  sta $8000,x
  clc
  adc #1
  inx
  cpx #40
  bne row
  
  lda row+1
  clc
  adc #40
  sta row+1
  lda row+2
  adc #0
  sta row+2
  iny
  cpy #25
  bne .nextro

  jsr char_init

  sei
  lda #$35
  sta $01
  lda #$7f
  sta $dc0d
  lda $dc0d
  ldx #$2e
.d000loop:
  lda up_d000defaults,x
  sta $d000,x
  dex
  bpl .d000loop
  inx
  stx up_irq_counter
  lda #%00000001
  sta $dd00   ;Bank at $8000-$bfff
;  lda #%00000011
;  sta $dd02
;  sta $dd03


  lda #$00
  sta up_current_row
  lda #$14
  sta up_current_rowpixel
  sei
  lda #<up_irq1
  sta $fffe
  lda #>up_irq1
  sta $ffff
  lda #$fc   ;set nmi to rti
  sta $fffa
  lda #$ff
  sta $fffb
  lda #$40   ;rti
  sta $fffc
  lda #<up_text
  sta up_textpoi
  lda #>up_text
  sta up_textpoi+1

  lda #$40
  sta up_thisrow_sprx
  lda #$0
  sta up_current_xdraw
  sta up_underline
  sta up_sincou
  sta up_cou
  sta up_cou2
  sta up_pause
  jsr up_move

  lda #$01
  sta $d019
  cli

up_ever:
  lda up_current_row
  clc
  adc #$0e
  cmp #$0f
  bcc .go
  sbc #$0f
.go:
  sta up_draw_sprline
  asl
  adc #>up_sprites
  sta up_drawpoi+1
  lda #$00
  sta up_drawpoi
  lda up_thisrow_sprx
  ldx up_draw_sprline
  sta up_xpositions,x
  lda #$00
  sta up_current_xdraw
  sta up_underline
  tax
.clr:
  sta up_tmpsprites1,x
  sta up_tmpsprites2,x
  inx
  bne .clr
up_nextchar:
  ldy #$00
  lda (up_textpoi),y

;6e94      kollar om texten Sr slut #$ff

  cmp #$ff
  bne .no_end
  jmp up_end_part

.no_end:
;6e9b      kollar om raden Sr slut #$fe, kopierar 6c00-6dff till ($0d), dvs vsr sprite. vSntar ps irq och gsr tillbaka till ever
  cmp #$f8
  bne .no_pause
;  lda #$80
  sta up_pause
  inc up_textpoi
  bne .nowrpa
  inc up_textpoi+1
.nowrpa
  jmp up_nextchar
.no_pause:
  cmp #$fe
  bne .no_endrow
  ldy #$00
.lo98:
  lda up_tmpsprites1,y
  sta (up_drawpoi),y
  iny
  bne .lo98
  inc up_drawpoi+1
.lo99:
  lda up_tmpsprites2,y
  sta (up_drawpoi),y
  iny
  bne .lo99
  inc up_textpoi
  bne .nowre
  inc up_textpoi+1
.nowre:
  lda up_current_row
.wait_next_line:
  cmp up_current_row
  beq .wait_next_line
  jmp up_ever

;6ec2      kollar om #$f9, tar nSsta byte i texten och sStter i x-pos fr rad $72a0,x

.no_endrow:
  cmp #$f9
  bne .no_setx
  iny
  lda (up_textpoi),y
  ldx up_draw_sprline
  sta up_thisrow_sprx
  sta up_xpositions,x
  lda #$02
  jsr up_inc_textpoi_with_a
  jmp up_nextchar

;6ed8      kollar om #$fa, inverterar msb i $0c = understrykning on/off
.no_setx:
  cmp #$fa
  bne .no_underline
  lda up_underline
  eor #$80
  sta up_underline
  inc up_textpoi
  bne .nowr
  inc up_textpoi+1
.nowr:
  jmp up_nextchar

;6eeb      kollar om #$fb, lSgger nSsta byte i texten i $0b. lda #$2 jsr $7086
.no_underline:
  cmp #$fb
  bne .no_set_sprsx
  iny
  lda (up_textpoi),y
  sta up_current_xdraw
  lda #$02
  jsr up_inc_textpoi_with_a
  jmp up_nextchar

;6efc      kollar om #$fd, hgerjusterar denna raden som kommer.
.no_set_sprsx:
  cmp #$fd
  bne .no_rightmargin
  sty up_tmp
  iny
.nextchar:
  lda (up_textpoi),y
  iny
  tax
  bmi .nochar
  lda up_charwidths,x
  clc
  adc up_tmp
  sta up_tmp
.nochar:
  cpx #$fe
  bne .nextchar
  lda #$c0
  sec
  sbc up_tmp
  sta up_current_xdraw
  inc up_textpoi
  bne .nowr2
  inc up_textpoi+1
.nowr2:
  jmp up_nextchar

;6f25      kollar om #$fc, centrerar denna raden som kommer

.no_rightmargin:
  cmp #$fc
  bne .no_center
  sty up_tmp
  iny
.nextchar2:
  lda (up_textpoi),y
  iny
  tax
  bmi .nochar2
  lda up_charwidths,x
  clc
  adc up_tmp
  sta up_tmp
.nochar2:
  cpx #$fe
  bne .nextchar2
  lda #$c0
  sec
  sbc up_tmp
  lsr
  sta up_current_xdraw
  inc up_textpoi
  bne .nowr3
  inc up_textpoi+1
.nowr3:
  jmp up_nextchar

;6f4f-     rita tecken

.no_center:
  cmp #$60
  bcc .no_lower_case
  and #$1f
.no_lower_case:

  sta up_tmp
  tax
  lda up_charwidths,x
  sta up_thischar_width
  lda #$00
  sta up_charpoi
  txa
  lsr
  ror up_charpoi
  lsr
  ror up_charpoi
  lsr
  ror up_charpoi
  adc #>up_charset
  sta up_charpoi+1

  ldy #$0f
.lo1:
  lda (up_charpoi),y
  sta up_20,y
  dey
  bpl .lo1
  lda up_charpoi
  clc
  adc #$10
  sta up_charpoi

  ldy #$0f
.lo2:
  lda (up_charpoi),y
  sta up_31,y
  dey
  bpl .lo2

  ldy #$10
  lda #$00
.lo3:
  sta up_42,y
  dey
  bpl .lo3
  lda #$00
  sta up_30
  sta up_41

;6f94      kollar msb i $0c. understrykning

  bit up_underline
  bpl .no_draw_underline
  ldx up_thischar_width
  lda up_underline1,x
  sta up_30
  lda up_underline2,x
  sta up_41

;6fa4      skiftar runt tecken i sidled

.no_draw_underline:
  lda up_current_xdraw
  and #$07
  beq .noshift
  tay
.next_round:
  ldx #$10
.next_row:
  lsr up_20,x
  ror up_31,x
  ror up_42,x
  dex
  bpl .next_row
  dey
  bne .next_round

.noshift:
  lda up_current_xdraw
  lsr
  lsr
  lsr
  tax
  stx up_tmp
  lda up_pointers_lsb,x
  sta up_charpoi
  lda up_pointers_msb,x
  sta up_charpoi+1

;6fcb      kopierar in tecken i sprite

  ldx #$00
  ldy #$00
.lo20:
  lda up_20,x
  ora (up_charpoi),y
  sta (up_charpoi),y
  inx
  iny
  iny
  iny
  cpx #$11
  bne .lo20

  ldx up_tmp
  inx
  cpx #$18
  beq up_finish_char

  lda up_pointers_lsb,x
  sta up_charpoi
  lda up_pointers_msb,x
  sta up_charpoi+1
  ldx #$00
  ldy #$00
.lo_31:
  lda up_31,x
  ora (up_charpoi),y
  sta (up_charpoi),y
  inx
  iny
  iny
  iny
  cpx #$11
  bne .lo_31

  ldx up_tmp
  inx
  inx
  cpx #$18
  beq up_finish_char
  lda up_pointers_lsb,x
  sta up_charpoi
  lda up_pointers_msb,x
  sta up_charpoi+1
  ldx #$00
  ldy #$00
.lo_42:
  lda up_42,x
  ora (up_charpoi),y
  sta (up_charpoi),y
  inx
  iny
  iny
  iny
  cpx #$11
  bne .lo_42

;7024-7033 slut ps plats i rad. kar pixelpos med teckenbredd
up_finish_char:
  lda up_thischar_width
  clc
  adc up_current_xdraw
  sta up_current_xdraw
  inc up_textpoi
  bne .nowr8
  inc up_textpoi+1
.nowr8:
  jmp up_nextchar

;7034-     beror ps teckenbredd, $30. ritar ett streck, kanske?
up_underline1:
 dc.b $00, $80, $c0, $e0, $f0, $f8, $fc, $fe
 dc.b $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff

;7045-     beror ps teckenbredd, $41
up_underline2:
 dc.b $00, $00, $00, $00, $00, $00, $00, $00
 dc.b $00, $80, $c0, $e0, $f0, $f8, $fc, $fe, $ff

;7056-     beror ps position(byte). pekare till spriteraden nsgonstans $6c00-6dc2
up_pointers_lsb:
 dc.b $00,$01,$02,$40,$41,$42,$80,$81,$82,$c0,$c1,$c2
 dc.b $00,$01,$02,$40,$41,$42,$80,$81,$82,$c0,$c1,$c2

;706e-     beror ps position(byte)
up_pointers_msb:
 ds.b 12,>up_tmpsprites1
 ds.b 12,>up_tmpsprites2
;6c 6c 6c 6c 6c 6c 6c 6c
;6c 6c 6c 6c 6d 6d 6d 6d
;6d 6d 6d 6d 6d 6d 6d 6d

;7086-729f irq-kod

up_inc_textpoi_with_a:
  clc
  adc up_textpoi
  sta up_textpoi
  bcc .nowr9
  inc up_textpoi+1
.nowr9:
  rts

up_move:
  inc up_cou
  bne .hh
  inc up_cou+1
.hh
  lda up_cou2
  and #1
  bne .g1
  lda up_cou
  eor #$ff
  tax
  lda costbl,x
  cmp #$80
  ror
  sta up_sincou
.g1:
  rts

up_irq1:
  bit $dc0d
  bmi .noirq2
  jmp up_irq2
.noirq2:
  cli
  pha
  txa
  pha
  lda $d001
  clc
  adc #$15
  ldx up_sprites_ypos
  bne .sety
  cmp #$24
  bcc .sety
  sbc #$38
.sety:
  sta $d001
  sta $d003
  sta $d005
  sta $d007
  sta $d009
  sta $d00b
  sta $d00d
  sta $d00f
;set spritepointers
  lda up_current_displayrow
  asl
  asl
  asl
  clc
  adc #$80
  tax
  stx screen_sprite_pointers
  inx
  stx screen_sprite_pointers+1
  inx
  stx screen_sprite_pointers+2
  inx
  stx screen_sprite_pointers+3
  inx
  stx screen_sprite_pointers+4
  inx
  stx screen_sprite_pointers+5
  inx
  stx screen_sprite_pointers+6
  inx
  stx screen_sprite_pointers+7
;setx:
  ldx up_current_displayrow
  lda up_xpositions,x
  bne .use_this_x

  lda $d001
  clc
  adc up_sincou
  tax
  lda sintbl,x
  adc #$80
  lsr

.use_this_x:
  ldx #0
  clc
  adc #$18
  sta $d000
  adc #$18
  sta $d002
  adc #$18
  sta $d004
  adc #$18
  sta $d006
  adc #$18
  sta $d008
  adc #$18
  sta $d00a
  bcc .no_3msb
  ldx #$e0
  stx $d010
  clc
.no_3msb:
  adc #$18
  sta $d00c
  bcc .no_2msb
  ldx #$c0
  stx $d010
  clc
.no_2msb:
  adc #$18
  sta $d00e
  bcc .no_1msb
  ldx #$80
.no_1msb:
  stx $d010

;next:
  ldx up_current_displayrow
  inx
  cpx #$f
  bne .nowra
  ldx #0
.nowra:
  stx up_current_displayrow
  ldx up_sprites_ypos
  inx
  stx up_sprites_ypos
  cpx #$0d
  bne .no_new_row

  lda #$7f
  sta $dc0d
  lda $dc0d

;Scroll only every other screen:
;  inc up_toggle
;  lda up_toggle
;  lsr
;  bcc .no_new_row

  ldx up_pause
  beq .up_running
  dex
  stx up_pause
  jmp .no_new_row

.up_running:

  ldx up_current_rowpixel
  dex
  stx up_current_rowpixel
  bpl .no_new_row
  ldx #$14
  stx up_current_rowpixel
  ldx up_current_row
  inx
  cpx #$0f
  bne .nowrb
  ldx #0
.nowrb:
  stx up_current_row

.no_new_row:
  lda up_sprites_ypos
  cmp #$01
  bne .no_music
;  cmp #$04
;  beq .music
;  cmp #$07
;  beq .music
;  cmp #$0a
;  bne .no_music
.music:
  tya
  pha
;  nop
;  nop
;  nop
  jsr up_move
  jsr char_rut
  jsr MUSIC_PLAY

  pla
  tay
.no_music:
  pla
  tax
  pla
  rti

up_irq2:
  pha
  lda up_irq_counter
  bne up_irq3
  lda #$90
  sta $d011
  lda #$1f
  sta $d012
  lda #$01
  sta up_irq_counter
  sta $d019
  pla
  rti

up_irq3:
  cmp #$01
  bne up_irq4
  lda #$26
  sta $d012
  inc up_irq_counter
  lda #$01
  sta $d019
  nop
  nop
  nop
  lda #$ff
  sta $bfff
  pla
  rti

up_irq4:
  cmp #$02
  beq .up_irq6
  jmp up_irq5

.up_irq6:
  lda #$18
  sta $d011
  lda up_current_rowpixel
  sec
  sbc #$06
  bcs .h
  adc #$38
.h:
  sta $d001
  sta $d003
  sta $d005
  sta $d007
  sta $d009
  sta $d00b
  sta $d00d
  sta $d00f
  txa
  pha
  lda up_current_row
  asl
  asl
  asl
  clc
  adc #$80
;  lda #3
  tax
  stx screen_sprite_pointers
  inx
  stx screen_sprite_pointers+1
  inx
  stx screen_sprite_pointers+2
  inx
  stx screen_sprite_pointers+3
  inx
  stx screen_sprite_pointers+4
  inx
  stx screen_sprite_pointers+5
  inx
  stx screen_sprite_pointers+6
  inx
  stx screen_sprite_pointers+7

  ldx up_current_row
  lda up_xpositions,x
  bne .use_this_x2

  lda $d001
  clc
  adc up_sincou
  tax
  lda sintbl,x
  adc #$80
  lsr

.use_this_x2:
;  ldx up_current_row
;  lda up_xpositions,x
  ldx #$00
  clc
  adc #$18
  sta $d000
  adc #$18
  sta $d002
  adc #$18
  sta $d004
  adc #$18
  sta $d006
  adc #$18
  sta $d008
  adc #$18
  sta $d00a
  bcc .noo_3msb
  ldx #$e0
  clc
.noo_3msb:
  adc #$18
  sta $d00c
  bcc .noo_2msb
  ldx #$c0
  clc
.noo_2msb:
  adc #$18
  sta $d00e
  bcc .noo_1msb
  ldx #$80
.noo_1msb:
  stx $d010
  lda up_current_rowpixel
  sec
  sbc #$0b
  bcs .k
  adc #$38
.k:
  ldx #$2a
  stx $dc04
  ldx #$05
  stx $dc05
  ldx #$91
.wait_raster:
  cmp $d012
  bne .wait_raster
  stx $dc0e

  lda #$81
  sta $dc0d
  lda $dc0d
  lda #$00
  sta up_sprites_ypos
  ldx up_current_row
  inx
  cpx #$0f
  bne .nowrc
  ldx #$00
.nowrc:
  stx up_current_displayrow
  lda #$0e
  sta $d012
  inc up_irq_counter
  lda #$01
  sta $d019
  pla
  tax
  pla
  rti

up_irq5:
  lda #$f8
  sta $d012
  lda #$00
  sta up_irq_counter
  lda #$01
  sta $d019
  lda #$00
  sta $bfff
  pla
  rti

;###
;###
;###

up_end_part:
  lda #0
  sta $dc0e ;stop timers
  lda #$7f
  sta $dc0d
  lda $dc0d
;  jmp next_demo_part
  rts







; seg.u tmp_sprites
 align $100
up_tmpsprites1: ds.b 256,0
up_tmpsprites2: ds.b 256,0

char_wait:
  dc.b $40
char_cou:
  dc.b $00

char_init:
  rts

char_rut:
	lda char_wait
	beq .do_char_rut
	dec char_wait
	rts
.do_char_rut:
  rts

 org $8000
screen:
  ds.b $3f8,0
  ds.b $8,0

chars:
  ds.b $138,0

  dc.b %00000000
  dc.b %00000000
  dc.b %00000000
  dc.b %00000000
  dc.b %00000011
  dc.b %00001111
  dc.b %00111111
  dc.b %11111111

  dc.b %00000011
  dc.b %00001111
  dc.b %00111111
  dc.b %11111111
  dc.b %11111111
  dc.b %11111111
  dc.b %11111111
  dc.b %11111111

  dc.b %11111111
  dc.b %11111111
  dc.b %11111111
  dc.b %11111111
  dc.b %11111111
  dc.b %11111111
  dc.b %11111111
  dc.b %11111111

  dc.b %11111111
  dc.b %11111111
  dc.b %11111111
  dc.b %11111111
  dc.b %11111111
  dc.b %11111111
  dc.b %11111111
  dc.b %11111111

  dc.b %11111111
  dc.b %11111111
  dc.b %11111111
  dc.b %11111111
  dc.b %11111100
  dc.b %11110000
  dc.b %11000000
  dc.b %00000000

  dc.b %11111100
  dc.b %11110000
  dc.b %11000000
  dc.b %00000000
  dc.b %00000000
  dc.b %00000000
  dc.b %00000000
  dc.b %00000000

  ds.b $800,0

 org $a000
up_sprites:









;###
;###
;###

 org $c000
; align $100

up_charset:
;@
 dc.b %00001111
 dc.b %00111000
 dc.b %01110000
 dc.b %01110000
 dc.b %11100111
 dc.b %11101100
 dc.b %11100000
 dc.b %11100111
 dc.b %11101100
 dc.b %11101100
 dc.b %11101100
 dc.b %11100111
 dc.b %01110000
 dc.b %01110000
 dc.b %00111100
 dc.b %00001111

 dc.b %11100000
 dc.b %01111000
 dc.b %00011100
 dc.b %00011100
 dc.b %11001110
 dc.b %01101110
 dc.b %01101110
 dc.b %11101110
 dc.b %01101110
 dc.b %01101110
 dc.b %01101110
 dc.b %10111100
 dc.b %00000000
 dc.b %00011100
 dc.b %00111100
 dc.b %11110000

;a
 dc.b $00,$00,$7e,$e7,$e7,$07,$7f,$e7
 dc.b $e7,$e7,$e7,$e7,$7b,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;b
 dc.b $e0,$e0,$fe,$e7,$e7,$e7,$e7,$e7
 dc.b $e7,$e7,$e7,$e7,$de,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;c
 dc.b $00,$00,$7e,$e7,$e7,$e0,$e0,$e0
 dc.b $e0,$e0,$e7,$e7,$7e,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;d
 dc.b $07,$07,$7f,$e7,$e7,$e7,$e7,$e7
 dc.b $e7,$e7,$e7,$e7,$7b,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;e
 dc.b $00,$00,$7e,$e7,$e7,$e7,$ff,$e0
 dc.b $e0,$e0,$e7,$e7,$7e,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;f
 dc.b $38,$70,$70,$70,$70,$70,$fc,$70
 dc.b $70,$70,$70,$70,$70,$70,$70,$70
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;g
 dc.b $00,$00,$7e,$e7,$e7,$e7,$e7,$e7
 dc.b $e7,$e7,$e7,$e7,$7f,$07,$e7,$7e
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;h
 dc.b $e0,$e0,$fe,$e7,$e7,$e7,$e7,$e7
 dc.b $e7,$e7,$e7,$e7,$e7,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;i
 dc.b $e0,$e0,$e0,$00,$e0,$e0,$e0,$e0
 dc.b $e0,$e0,$e0,$e0,$70,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;j
 dc.b $70,$70,$70,$00,$70,$70,$70,$70
 dc.b $70,$70,$70,$70,$70,$70,$70,$e0
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;k
 dc.b $e0,$e0,$e7,$e7,$e6,$fc,$e6,$e7
 dc.b $e7,$e7,$e7,$e7,$e7,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;l
 dc.b $e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0
 dc.b $e0,$e0,$e0,$e0,$e0,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;m
 dc.b $00,$00,$dd,$e6,$e6,$e6,$e6,$e6
 dc.b $e6,$e6,$e6,$e6,$e6,$00,$00,$00
 dc.b $00,$00,$e0,$70,$70,$70,$70,$70
 dc.b $70,$70,$70,$70,$70,$00,$00,$00
;n
 dc.b $00,$00,$de,$e7,$e7,$e7,$e7,$e7
 dc.b $e7,$e7,$e7,$e7,$e7,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;o
 dc.b $00,$00,$7e,$e7,$e7,$e7,$e7,$e7
 dc.b $e7,$e7,$e7,$e7,$7e,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;p
 dc.b $00,$00,$fe,$e7,$e7,$e7,$e7,$e7
 dc.b $e7,$e7,$e7,$e7,$fe,$e0,$e0,$e0
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;q
 dc.b $00,$00,$7f,$e7,$e7,$e7,$e7,$e7
 dc.b $e7,$e7,$e7,$e7,$7f,$07,$07,$07
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;r
 dc.b $00,$00,$de,$e7,$e7,$e0,$e0,$e0
 dc.b $e0,$e0,$e0,$e0,$e0,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;s
 dc.b $00,$00,$7f,$e7,$e7,$e0,$e0,$7e
 dc.b $07,$07,$e7,$e7,$fe,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;t
 dc.b $70,$70,$f8,$70,$70,$70,$70,$70
 dc.b $70,$70,$70,$70,$38,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;u
 dc.b $00,$00,$e7,$e7,$e7,$e7,$e7,$e7
 dc.b $e7,$e7,$e7,$e7,$7e,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;v
 dc.b $00,$00,$e7,$e7,$e7,$e7,$e7,$e7
 dc.b $e7,$e7,$66,$3c,$18,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;w
 dc.b $00,$00,$e6,$e6,$e6,$e6,$e6,$e6
 dc.b $e6,$e6,$e6,$e6,$7f,$00,$00,$00
 dc.b $00,$00,$70,$70,$70,$70,$70,$70
 dc.b $70,$70,$70,$70,$e0,$00,$00,$00
;x
 dc.b $00,$00,$e7,$e7,$e7,$e7,$e7,$7e
 dc.b $e7,$e7,$e7,$e7,$e7,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;y
 dc.b $00,$00,$e7,$e7,$e7,$e7,$e7,$e7
 dc.b $e7,$e7,$e7,$e7,$7f,$07,$e7,$7e
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;z
 dc.b $00,$00,$ff,$e7,$07,$0e,$1c,$38
 dc.b $70,$e0,$e7,$e7,$ff,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;[
 dc.b $f8,$e0,$e0,$e0,$e0,$e0,$e0,$e0
 dc.b $e0,$e0,$e0,$e0,$e0,$f8,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;o + /
 dc.b $00,$00,$7e,$e7,$e7,$e7,$ef,$ff
 dc.b $f7,$e7,$e7,$e7,$7e,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;]
 dc.b $f8,$38,$38,$38,$38,$38,$38,$38
 dc.b $38,$38,$38,$38,$38,$f8,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;o + " = 
 dc.b $e7,$00,$7e,$e7,$e7,$e7,$e7,$e7
 dc.b $e7,$e7,$e7,$e7,$7e,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;s
 dc.b $3c,$00,$7e,$e7,$e7,$07,$7f,$e7
 dc.b $e7,$e7,$e7,$e7,$7b,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;" "
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;!
 dc.b $e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0
 dc.b $e0,$00,$e0,$e0,$e0,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;"
 dc.b $e7,$e7,$e7,$63,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;" - endquote
 dc.b $e7,$e7,$e7,$c6,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;$
 dc.b $18,$18,$7e,$e7,$e7,$e0,$7e,$07
 dc.b $07,$e7,$e7,$7e,$18,$18,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;%
 dc.b $e3,$e3,$e6,$06,$0c,$0c,$18,$18
 dc.b $30,$30,$60,$67,$c7,$c7,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;& (empty)
;e'
 dc.b $0c,$30,$7e,$e7,$e7,$e7,$ff,$e0
 dc.b $e0,$e0,$e7,$e7,$7e,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;'
 dc.b $e0,$e0,$e0,$c0,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;(
 dc.b $70,$e0,$e0,$e0,$e0,$e0,$e0,$e0
 dc.b $e0,$e0,$e0,$e0,$e0,$70,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;)
 dc.b $e0,$70,$70,$70,$70,$70,$70,$70
 dc.b $70,$70,$70,$70,$70,$e0,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;S = a + "
 dc.b $66,$00,$7e,$e7,$e7,$07,$7f,$e7
 dc.b $e7,$e7,$e7,$e7,$7b,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;+
 dc.b $00,$00,$00,$00,$38,$38,$fe,$38
 dc.b $38,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;,
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$e0,$e0,$e0,$c0,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;-
 dc.b $00,$00,$00,$00,$00,$00,$fe,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;.
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$e0,$e0,$e0,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;/
 dc.b $03,$03,$06,$06,$0c,$0c,$18,$18
 dc.b $30,$30,$60,$60,$c0,$c0,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;0
 dc.b $7e,$e7,$e7,$e7,$e7,$ef,$ff,$f7
 dc.b $e7,$e7,$e7,$e7,$7e,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;1
 dc.b $1c,$3c,$7c,$dc,$1c,$1c,$1c,$1c
 dc.b $1c,$1c,$1c,$1c,$1c,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;2
 dc.b $7e,$e7,$e7,$e7,$07,$0e,$1c,$38
 dc.b $70,$e0,$e7,$e7,$ff,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;3
 dc.b $7e,$e7,$e7,$e7,$07,$07,$1e,$07
 dc.b $07,$07,$e7,$e7,$7e,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;4
 dc.b $e7,$e7,$e7,$e7,$e7,$e7,$7f,$07
 dc.b $07,$07,$07,$07,$07,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
;5
 dc.b $ff,$e7,$e7,$e0,$e0,$e0,$fe,$07
 dc.b $07,$07,$e7,$e7,$7e,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $7e,$e7,$e7,$e0,$e0,$e0,$fe,$e7
 dc.b $e7,$e7,$e7,$e7,$7e,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $ff,$e7,$07,$07,$07,$07,$1f,$07
 dc.b $07,$07,$07,$07,$07,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$80,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $7e,$e7,$e7,$e7,$e7,$e7,$7e,$e7
 dc.b $e7,$e7,$e7,$e7,$7e,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $7e,$e7,$e7,$e7,$e7,$e7,$7f,$07
 dc.b $07,$07,$e7,$e7,$7e,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$e0,$e0,$e0,$00,$e0
 dc.b $e0,$e0,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$e0,$e0,$e0,$00,$e0
 dc.b $e0,$e0,$60,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$fe,$00,$fe
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $7e,$e7,$e7,$e7,$07,$07,$1e,$38
 dc.b $38,$00,$38,$38,$38,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $7e,$e7,$e7,$e7,$e7,$e7,$ff,$e7
 dc.b $e7,$e7,$e7,$e7,$e7,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $fe,$e7,$e7,$e7,$e7,$e7,$fe,$e7
 dc.b $e7,$e7,$e7,$e7,$fe,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $7e,$e7,$e7,$e0,$e0,$e0,$e0,$e0
 dc.b $e0,$e0,$e7,$e7,$7e,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $fe,$e7,$e7,$e7,$e7,$e7,$e7,$e7
 dc.b $e7,$e7,$e7,$e7,$fe,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $fe,$e0,$e0,$e0,$e0,$e0,$f8,$e0
 dc.b $e0,$e0,$e0,$e0,$fe,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $fe,$e0,$e0,$e0,$e0,$e0,$f8,$e0
 dc.b $e0,$e0,$e0,$e0,$e0,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $7e,$e7,$e7,$e0,$e0,$e0,$ef,$e7
 dc.b $e7,$e7,$e7,$e7,$7e,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $e7,$e7,$e7,$e7,$e7,$e7,$ff,$e7
 dc.b $e7,$e7,$e7,$e7,$e7,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $f8,$70,$70,$70,$70,$70,$70,$70
 dc.b $70,$70,$70,$70,$f8,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $70,$70,$70,$70,$70,$70,$70,$70
 dc.b $70,$70,$70,$70,$70,$70,$70,$e0
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $e7,$e7,$e7,$e7,$e6,$fc,$e6,$e7
 dc.b $e7,$e7,$e7,$e7,$e7,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0
 dc.b $e0,$e0,$e0,$e0,$fc,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $7f,$e6,$e6,$e6,$e6,$e6,$e6,$e6
 dc.b $e6,$e6,$e6,$e6,$e6,$00,$00,$00
 dc.b $e0,$70,$70,$70,$70,$70,$70,$70
 dc.b $70,$70,$70,$70,$70,$00,$00,$00
 dc.b $fe,$e7,$e7,$e7,$e7,$e7,$e7,$e7
 dc.b $e7,$e7,$e7,$e7,$e7,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $7e,$e7,$e7,$e7,$e7,$e7,$e7,$e7
 dc.b $e7,$e7,$e7,$e7,$7e,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $fe,$e7,$e7,$e7,$e7,$e7,$fe,$e0
 dc.b $e0,$e0,$e0,$e0,$e0,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $7e,$e7,$e7,$e7,$e7,$e7,$e7,$e7
 dc.b $e7,$e7,$e7,$e7,$7e,$07,$03,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $fe,$e7,$e7,$e7,$e7,$e7,$fe,$e7
 dc.b $e7,$e7,$e7,$e7,$e7,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $7e,$e7,$e7,$e7,$e0,$e0,$7e,$07
 dc.b $07,$e7,$e7,$e7,$fe,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $ff,$1c,$1c,$1c,$1c,$1c,$1c,$1c
 dc.b $1c,$1c,$1c,$1c,$1c,$00,$00,$00
 dc.b $80,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $e7,$e7,$e7,$e7,$e7,$e7,$e7,$e7
 dc.b $e7,$e7,$e7,$e7,$7f,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $e7,$e7,$e7,$e7,$e7,$e7,$e7,$e7
 dc.b $e7,$e7,$66,$3c,$18,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $e6,$e6,$e6,$e6,$e6,$e6,$e6,$e6
 dc.b $e6,$e6,$e6,$e6,$7f,$00,$00,$00
 dc.b $70,$70,$70,$70,$70,$70,$70,$70
 dc.b $70,$70,$70,$70,$e0,$00,$00,$00
 dc.b $e7,$e7,$e7,$e7,$e7,$e7,$7e,$e7
 dc.b $e7,$e7,$e7,$e7,$e7,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $e7,$e7,$e7,$e7,$e7,$e7,$7f,$07
 dc.b $07,$07,$e7,$e7,$7e,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $ff,$e7,$e7,$e7,$07,$0e,$1c,$38
 dc.b $70,$e7,$e7,$e7,$ff,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00

up_charwidths:
;a-z
 dc.b $10, $09, $09, $09, $09, $09, $07, $09
 dc.b $09, $05, $05, $09, $04, $0d, $09, $09
 dc.b $09, $09, $09, $09, $06, $09, $09, $0d
 dc.b $09, $09, $09, $06, $09, $06, $09, $09 ;xyz[o]s
;$20-$3f
 dc.b $06, $04, $09, $09, $09, $09, $09, $04 ; !"#%&   ;&=T
 dc.b $05, $05, $09, $08, $04, $08, $04, $09
 dc.b $09, $07, $09, $09, $09, $09, $09, $0a
 dc.b $09, $09, $04, $04, $00, $08, $00, $09
;A-Z
 dc.b $00, $09, $09, $09, $09, $08, $08, $09
 dc.b $09, $06, $05, $09, $07, $0d, $09, $09
 dc.b $09, $09, $09, $09, $0a, $09, $09, $0d
 dc.b $09, $09, $09, $00, $00, $00, $00, $00
;a-z
 dc.b $10, $09, $09, $09, $09, $09, $07, $09
 dc.b $09, $05, $05, $09, $04, $0d, $09, $09
 dc.b $09, $09, $09, $09, $06, $09, $09, $0d
 dc.b $09, $09, $09, $06, $09, $06, $09, $09 ;xyz[o]s

up_xpositions:
 dc.b $40,$40,$40,$40,$40,$40,$40,$40
 dc.b $40,$40,$40,$40,$40,$40,$40

up_d000defaults:
 dc.b $00, $00, $00, $00, $00, $00, $00, $00
 dc.b $00, $00, $00, $00, $00, $00, $00, $00
 dc.b $00, $1b, $f8, $00, $00, $ff, $08, $00
 dc.b $00, $01, $01, $ff, $00, $00, $00, $00
 dc.b $00, $00, $00, $00, $00, $00, $00, $01
 dc.b $01, $01, $01, $01, $01, $01, $01


;###
;### up-text
;###

	org $e000
up_text:
 dc.b $f9,$40,$fc,"You have seen",$fe
 dc.b " ",$fe
 dc.b $fc,"EXIT",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b $fc,"Released at the",$fe
 dc.b $fc,"S:t Lars meeting",$fe
 dc.b $fc,"in Lund, Sweden",$fe
 dc.b " ",$fe
 dc.b $fc,"18th of Feb 2006",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b $f9,1,$fa,"Coding by:",$fa,$fe
 dc.b $f9,$80,$fd,"Pex Mahoney Tufvesson",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b $f9,1,$fa,"Music:",$fa,$fe
 dc.b $f9,$80,$fd,"'Klanen Manne' by",$fe
 dc.b $fc,"Peter 'Yodelking' Sand&n",$fe
 dc.b $f9,$80,$fd,"UL-Tomten",$fe
 dc.b " ",$fe
 dc.b $f9,$80,$fd,"'Tr",")"+1,"gen Vinner' by",$fe
 dc.b $fc,"Peter 'Yodelking' Sand&n",$fe
 dc.b $f9,$80,$fd,"UL-Tomten",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b $f9,1,$fa,"Graphics:",$fa,$fe
 dc.b $f9,$80,$fd,"Defiers-logos",$fe
 dc.b $f9,$80,$fd,"JSL/Protovision",$fe
 dc.b $f9,$80,$fd,"and Covenant",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b $f9,1,$fa,"This charset by:",$fa,$fe
 dc.b $f9,$80,$fd,"Shaman of Taboo",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b $f9,1,$fa,"Inspiration from:",$fa,$fe
 dc.b $f9,$80,$fd,$fa,"Stable Raster IRQ",$fe
 dc.b $fd,"by Fungus 1996",$fe
 dc.b " ",$fe
; dc.b $f9,$80,$fd,$fa,"Sprite multiplexing",$fe
; dc.b $fd,"by Lasse ","z"+4,"z"+4,"rni",$fe
; dc.b " ",$fe
 dc.b $f9,$80,$fd,$fa,"Altered States",$fe
 dc.b $fd,"by Taboo 1994",$fe
 dc.b $fd,"Endscroll code by MMS",$fe
 dc.b " ",$fe

 dc.b $f9,1,$fa,"Tools used:",$fa,$fe
 dc.b $f9,$80,$fd,$fa,"CodeWright 7.5",$fe
 dc.b $fd,"text editor for win32",$fe
 dc.b " ",$fe
 dc.b $fd,$fa,"Photoshop 8.0",$fe
 dc.b $fd,"graphics for win32",$fe
 dc.b " ",$fe
 dc.b $fd,$fa,"PuCrunch 8.3.2002",$fe
 dc.b $fd,"by Pasi Ojala",$fe
 dc.b $fd,"Packer for win32",$fe
 dc.b " ",$fe
 dc.b $fd,$fa,"XRay64 v0.1 beta3",$fe
 dc.b $fd,"by Jakub Prezes",$fe
 dc.b $fd,"Wozniakowski",$fe
 dc.b $fd,"Graphics conv for win32",$fe
 dc.b " ",$fe
 dc.b $fd,$fa,"Dasm v2.20.07",$fe
 dc.b $fd,"by Mattew Dillon",$fe
 dc.b $fd,"and Olaf 'Rhialto' Seibert",$fe
 dc.b " ",$fe
 dc.b $fd,$fa,"WinVice v1.19",$fe
 dc.b $fd,"Commodore64 emulator",$fe
 dc.b " ",$fe
 dc.b $fd,$fa,"ConGo v0.92",$fe
 dc.b $fd,"by Matthias Matting",$fe
 dc.b $fd,"Graphics conv for win32",$fe
 dc.b " ",$fe
 dc.b $fd,$fa,"Makedisk",$fe
 dc.b $fd,"by Lasse ","z"+4,"z"+4,"rni",$fe
 dc.b $fd,"d64-maker for win32",$fe
 dc.b " ",$fe
 dc.b $fd,$fa,"Goattracker v1.5",$fe
 dc.b $fd,"by Lasse ","z"+4,"z"+4,"rni",$fe
 dc.b $fd,"Musictracker for C64",$fe
 dc.b " ",$fe
 dc.b $fd,$fa,"StarCommander v0.82",$fe
 dc.b $fd,"by Joe Forster",$fe
 dc.b $fd,"C64files for win32",$fe
 dc.b " ",$fe
 dc.b " ",$fe

;
;
 dc.b $f9,$40,$fc,"Thanks to you all",$fe
 dc.b $fc,"for making these",$fe
 dc.b $fc,"wonderful tools.",$fe
 dc.b " ",$fe
 dc.b $fc,"Without them, this demo",$fe
 dc.b $fc,"would never been done!",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe



 dc.b $f9,0,$fa,$fc,"Greetings to:",$fa,$fe
 dc.b " ",$fe
 dc.b $f9,$40,$fc,"(analphabetic order)",$fe
 dc.b " ",$fe
 dc.b $f9,0,$fc,"Melina Tufvesson",$fe
 dc.b $fc,"John 'Ziphoid' Carehag",$fe
 dc.b $fc,"Carsten 'O2' Ohlsson",$fe
 dc.b $fc,"Markus Schneider",$fe
 dc.b $fc,"Rob Hubbard",$fe
 dc.b $fc,"Peter 'Yodelking' Sand&n",$fe
 dc.b $fc,"Marcus 'Makke' Nilsson",$fe
 dc.b $fc,"Slaygon/Censor",$fe
 dc.b $fc,"Gluemaster",$fe
 dc.b $fc,"Jan Lund Thomsen",$fe
 dc.b $fc,"Andreas Wallstr","z"+4,"m",$fe
 dc.b $fc,"Anders Berkeman",$fe
 dc.b $fc,"Ben Daglish",$fe
 dc.b $fc,"Karin ","z"+4,"jehagen",$fe
 dc.b $fc,"Sofia ","z"+5,"berg",$fe
 dc.b $fc,"Elsa Persson",$fe
 dc.b $fc,"Hanna Kappelin",$fe
 dc.b $fc,"Johannes Linden",$fe
 dc.b $fc,"Kent 'Trace' Walden",$fe
 dc.b $fc,"Rauli Sulanko",$fe
 dc.b $fc,"Holger Lagerfeldt",$fe
 dc.b $fc,"Glyn R. Brown",$fe
 dc.b $fc,"Neil 'Tas' Carr",$fe
 dc.b $fc,"Markus 'LMan' Klein",$fe
 dc.b $fc,"Stefan Burstr","z"+4,"m",$fe
 dc.b $fc,"Mark Knight",$fe
 dc.b $fc,"Stello Doussis",$fe
 dc.b $fc,"Sumppi",$fe
 dc.b $fc,"Anders Dellson",$fe
 dc.b $fc,"Ben Daglish",$fe
 dc.b $fc,"Deck/Scoopex",$fe
 dc.b $fc,"Thomas Detert",$fe
 dc.b $fc,"Marcus Nelson",$fe
 dc.b $fc,"LaLa",$fe
 dc.b $fc,"Wobbler",$fe
 dc.b $fc,"Jesper Johansson",$fe
 dc.b $fc,"DHS",$fe
 dc.b $fc,"Chris Abbott",$fe
 dc.b $fc,"TMB/Creators",$fe
 dc.b $fc,"Michael 'DjLizard' Cooke",$fe
 dc.b $fc,"Stefan 'Zingo' Andersen",$fe
 dc.b $fc,"Linus Walleij",$fe
 dc.b $fc,"Marcel Donn&",$fe
 dc.b $fc,"Robert Nilsson",$fe
 dc.b $fc,"Max Levin",$fe
 dc.b $fc,"Peter M","z"+4,"rck",$fe
 dc.b $fc,"Rafael Dyll",$fe
 dc.b $fc,"Johan N",")"+1,"sholm",$fe
 dc.b $fc,"Reyn Ouwehand",$fe
 dc.b $fc,"Mermaid/Creators",$fe
 dc.b $fc,"Slumgud",$fe
 dc.b $fc,"Erik Persson",$fe
 dc.b $fc,"Octave sounds",$fe
 dc.b $fc,"Sonic Wanderer",$fe
 dc.b $fc,"Janek Rooney",$fe
 dc.b $fc,"Larsec",$fe
 dc.b $fc,"Mikael Ericsson Duffy",$fe
 dc.b $fc,"Eliot",$fe
 dc.b $fc,"Che 'THC' Lalic",$fe
 dc.b $fc,"Per Bolmstedt",$fe
 dc.b $fc,"David Whittaker",$fe
 dc.b " ",$fe
 dc.b $f9,$40,$fc,"...and those I forgot!",$fe

 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe

 dc.b $f9,1,$fa,"Visit these sites:",$fa,$fe
 dc.b $f9,$80,$fd,"http://remix64.com",$fe
 dc.b $fd,"remix.kwed.org",$fe
 dc.b $fd,"http://livet.se/visa",$fe
 dc.b " ",$fe

 dc.b $f9,1,$fa,"Download sourcecode",$fa,$fe
 dc.b $f9,$80,$fd,"http://mahoney.c64.org",$fe
 dc.b " ",$fe

 dc.b $f9,1,$fa,"Contact me:",$fa,$fe
 dc.b $f9,$80,$fd,"mahoney",0,"c64.org",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe

 dc.b $f9,$40,$fc,"Check out C64 music",$fe
 dc.b $f9,$40,$fc,"a cappella by",$fe
 dc.b " ",$fe
 dc.b $f9,$40,$fc,"Visa R","z"+4,"ster",$fe
 dc.b " ",$fe
 dc.b $f9,$40,$fc,"http://livet.se/visa",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b $f8," ",$fe

 dc.b " ",$fe
 dc.b $f9,$40,$fc,"Have a noise night!",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe

; dc.b $f8," ",$fe
; dc.b " ",$fe
; dc.b " ",$fe

 dc.b $f9,$1,"I can feel it...",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b $f9,$40,$fc,"it's coming...",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b $f9,$80,$fd,"..the restart is near",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b $f9,1,"I see the light...",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b $f9,$40,$fc,"at the end of the tunnel",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b $f9,$80,$fd,"and it is very nice!!",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe
 dc.b " ",$fe

 dc.b $20,$ff

code_end:

